var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/account-provider/is-complete-handler.lambda.ts
var is_complete_handler_lambda_exports = {};
__export(is_complete_handler_lambda_exports, {
  handler: () => handler
});
var AWS = __toESM(require("aws-sdk"));
var organizationsClient;
async function handler(event) {
  var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l;
  console.log(`Request of type ${event.RequestType} received`);
  if (!organizationsClient) {
    organizationsClient = new AWS.Organizations({ region: "us-east-1" });
  }
  console.log("Payload: %j", event);
  let accountId;
  if ((_a = event.Data) == null ? void 0 : _a.CreateAccountStatusId) {
    const response2 = await organizationsClient.describeCreateAccountStatus({ CreateAccountRequestId: event.Data.CreateAccountStatusId }).promise();
    if (((_b = response2.CreateAccountStatus) == null ? void 0 : _b.State) == "IN_PROGRESS") {
      return { IsComplete: false, Data: {} };
    }
    if (((_c = response2.CreateAccountStatus) == null ? void 0 : _c.State) == "FAILED") {
      throw new Error(`Failed ${event.RequestType} Account ${(_d = response2.CreateAccountStatus) == null ? void 0 : _d.AccountName}, reason: ${(_e = response2 == null ? void 0 : response2.CreateAccountStatus) == null ? void 0 : _e.FailureReason}`);
    }
    accountId = (_f = response2.CreateAccountStatus) == null ? void 0 : _f.AccountId;
  } else {
    accountId = (_g = event.Data) == null ? void 0 : _g.AccountId;
  }
  const response = await organizationsClient.describeAccount({ AccountId: accountId }).promise();
  if (event.RequestType == "Create" || event.RequestType == "Update") {
    await move(organizationsClient, accountId, (_h = event.ResourceProperties) == null ? void 0 : _h.ParentId);
  }
  if (event.RequestType == "Delete" && ((_i = event.ResourceProperties) == null ? void 0 : _i.RemovalPolicy) == "destroy") {
    const root = await findRoot(organizationsClient);
    await move(organizationsClient, accountId, root.Id);
  }
  return {
    IsComplete: true,
    Data: __spreadProps(__spreadValues(__spreadValues({}, event.ResourceProperties), event.Data), {
      AccountId: accountId,
      AccountArn: (_j = response.Account) == null ? void 0 : _j.Arn,
      AccountName: (_k = response.Account) == null ? void 0 : _k.Name,
      Email: (_l = response.Account) == null ? void 0 : _l.Email
    })
  };
}
var findCurrentParent = async (client, id) => {
  var _a;
  const response = await client.listParents({
    ChildId: id
  }).promise();
  if ((_a = response.Parents) == null ? void 0 : _a.length) {
    return response.Parents[0];
  }
  throw new Error(`Could not find parent for id '${id}'`);
};
var findRoot = async (client) => {
  var _a;
  const response = await client.listRoots().promise();
  if ((_a = response.Roots) == null ? void 0 : _a.length) {
    return response.Roots[0];
  }
  throw new Error(`Could not find root`);
};
var move = async (client, accountId, destinationParentId) => {
  if (!destinationParentId) {
    return;
  }
  const currentParent = await findCurrentParent(organizationsClient, accountId);
  if (destinationParentId == currentParent.Id) {
    return;
  }
  await client.moveAccount({
    AccountId: accountId,
    SourceParentId: currentParent.Id,
    DestinationParentId: destinationParentId
  }).promise();
};
module.exports = __toCommonJS(is_complete_handler_lambda_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
//# sourceMappingURL=index.js.map
