var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/account-provider/on-event-handler.lambda.ts
var on_event_handler_lambda_exports = {};
__export(on_event_handler_lambda_exports, {
  handler: () => handler
});
var import_aws_sdk = require("aws-sdk");
var organizationsClient;
async function handler(event) {
  var _a, _b;
  console.log(`Request of type ${event.RequestType} received`);
  if (!organizationsClient) {
    organizationsClient = new import_aws_sdk.Organizations({ region: "us-east-1" });
  }
  console.log("Payload: %j", event);
  const { Email, AccountName, RoleName, IamUserAccessToBilling, ImportOnDuplicate } = event.ResourceProperties;
  if (event.RequestType == "Create" && ImportOnDuplicate == "true") {
    const account = await findAccountByEmail(organizationsClient, Email);
    if (account) {
      return {
        PhysicalResourceId: account.Id,
        Data: __spreadProps(__spreadValues({}, event.ResourceProperties), { AccountId: account.Id })
      };
    }
  }
  if (event.RequestType == "Create") {
    const response = await organizationsClient.createAccount({
      Email,
      AccountName,
      RoleName,
      IamUserAccessToBilling
    }).promise();
    console.log("Creating account: %j", response);
    return {
      PhysicalResourceId: (_a = response.CreateAccountStatus) == null ? void 0 : _a.Id,
      Data: __spreadProps(__spreadValues({}, event.ResourceProperties), { CreateAccountStatusId: (_b = response.CreateAccountStatus) == null ? void 0 : _b.Id })
    };
  }
  let data;
  if (/\d{12}/.test(event.PhysicalResourceId)) {
    data = { AccountId: event.PhysicalResourceId };
  } else {
    data = { CreateAccountStatusId: event.PhysicalResourceId };
  }
  return __spreadProps(__spreadValues({}, event), {
    Data: __spreadValues(__spreadValues({}, event.ResourceProperties), data)
  });
}
var findAccountByEmail = async (client, email) => {
  let response = await client.listAccounts().promise();
  for (const account of response.Accounts ?? []) {
    if (account.Email == email) {
      return account;
    }
  }
  while (response.NextToken) {
    response = await client.listAccounts().promise();
    for (const account of response.Accounts ?? []) {
      if (account.Email == email) {
        return account;
      }
    }
  }
  return void 0;
};
module.exports = __toCommonJS(on_event_handler_lambda_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
//# sourceMappingURL=index.js.map
