var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toCommonJS = /* @__PURE__ */ ((cache) => {
  return (module2, temp) => {
    return cache && cache.get(module2) || (temp = __reExport(__markAsModule({}), module2, 1), cache && cache.set(module2, temp), temp);
  };
})(typeof WeakMap !== "undefined" ? /* @__PURE__ */ new WeakMap() : 0);

// src/tag-resource-provider/on-event-handler.lambda.ts
var on_event_handler_lambda_exports = {};
__export(on_event_handler_lambda_exports, {
  handler: () => handler
});
var import_aws_sdk = require("aws-sdk");
var organizationsClient;
async function handler(event) {
  console.log(`Request of type ${event.RequestType} received`);
  if (!organizationsClient) {
    organizationsClient = new import_aws_sdk.Organizations({ region: "us-east-1" });
  }
  console.log("Payload: %j", event);
  const listTagsForResourceResponse = await organizationsClient.listTagsForResource({
    ResourceId: event.ResourceProperties.ResourceId
  }).promise();
  const oldTags = listTagsForResourceResponse.Tags ?? [];
  const oldTagKeys = oldTags.map((tag) => tag.Key);
  const newTags = event.ResourceProperties.Tags ?? [];
  const newTagKeys = newTags.map((tag) => tag.Key);
  const tagKeysToRemove = oldTagKeys.filter((tagKey) => !newTagKeys.includes(tagKey));
  if (tagKeysToRemove.length) {
    await organizationsClient.untagResource({
      ResourceId: event.ResourceProperties.ResourceId,
      TagKeys: tagKeysToRemove
    }).promise();
  }
  if (event.RequestType == "Delete") {
    return { PhysicalResourceId: event.PhysicalResourceId };
  }
  if (newTags.length) {
    await organizationsClient.tagResource({
      ResourceId: event.ResourceProperties.ResourceId,
      Tags: newTags
    }).promise();
  }
  return { PhysicalResourceId: event.ResourceProperties.ResourceId, ResourceProperties: event.ResourceProperties };
}
module.exports = __toCommonJS(on_event_handler_lambda_exports);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  handler
});
//# sourceMappingURL=index.js.map
