import { Construct } from "constructs";
/**
 * @experimental
 */
export interface EnableAwsServiceAccessProps {
    /**
     * (experimental) The service principal name of the AWS service for which you want to enable integration with your organization.
     *
     * This is typically in the form of a URL, such as service-abbreviation.amazonaws.com.
     *
     * @experimental
     */
    readonly servicePrincipal: string;
}
/**
 * (experimental) Enables the integration of an AWS service (the service that is specified by ServicePrincipal) with AWS Organizations.
 *
 * When you enable integration, you allow the specified service to create a service-linked role in all the accounts in your organization. This allows the service to perform operations on your behalf in your organization and its accounts.
 *
 * <strong>This operation can be called only from the organization's management account and only if the organization has enabled all features.</strong>
 *
 * @see https://docs.aws.amazon.com/organizations/latest/userguide/orgs_integrate_services.html#orgs_trusted_access_perms
 * @experimental
 */
export declare class EnableAwsServiceAccess extends Construct {
    /**
     * @experimental
     */
    constructor(scope: Construct, id: string, props: EnableAwsServiceAccessProps);
}
