import { Construct } from "constructs";
import { Root } from "./organization";
import { PolicyType } from "./policy";
/**
 * @experimental
 */
export interface EnablePolicyTypeProps {
    /**
     * @experimental
     */
    readonly root: Root;
    /**
     * @experimental
     */
    readonly policyType: PolicyType;
}
/**
 * (experimental) Enables and disables Enables a policy type in a root.
 *
 * After you enable a policy type in a root, you can attach policies of that type to the root, any organizational unit (OU), or account in that root.
 *
 * @see https://docs.aws.amazon.com/organizations/latest/userguide/orgs_manage_policies_enable-disable.html
 * @experimental
 */
export declare class EnablePolicyType extends Construct {
    /**
     * @experimental
     */
    constructor(scope: Construct, id: string, props: EnablePolicyTypeProps);
}
