import { ITaggable } from "aws-cdk-lib";
import { IResolvable } from "aws-cdk-lib/core/lib/resolvable";
import { Construct } from "constructs";
/**
 * @experimental
 */
export interface ITaggableResource extends ITaggable {
}
/**
 * @experimental
 */
export interface TagResourceProps {
    /**
     * @experimental
     */
    readonly resourceId: string;
    /**
     * @experimental
     */
    readonly tags: IResolvable;
}
/**
 * (experimental) Add tags to an AWS Organizations resource to make it easier to identify, organize, and search.
 *
 * @see https://docs.aws.amazon.com/ARG/latest/APIReference/API_Tag.html
 * @experimental
 */
export declare class TagResource extends Construct {
    /**
     * @experimental
     */
    constructor(scope: Construct, id: string, props: TagResourceProps);
}
